%global pkg iwlegacy

%global kernel_version 4.18.0-338.el8

%global _use_internal_dependency_generator 0
%global __find_requires %{nil}
%global __find_provides /usr/lib/rpm/find-provides

%global debug_package %{nil}

%global __spec_install_post \
  %{?__debug_package:%{__debug_install_post}} \
  %{__arch_install_post} \
  %{__os_install_post} \
  %{__mod_compress_install_post}

%global __mod_compress_install_post find %{buildroot}/lib/modules -type f -name \*.ko -exec xz \{\} \\;


Name:             kmod-%{pkg}
Version:          5.12
Release:          5%{?dist}
Summary:          Intel WiFi 3945ABG/BG (iwl3945) and 4965AGN (iwl4965) driver

License:          GPLv2
URL:              https://www.kernel.org/

Source0:          %{pkg}-%{version}.tar.xz

ExclusiveArch:    x86_64

BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    redhat-rpm-config
BuildRequires:    xz

BuildRequires:    kernel-devel = %{kernel_version}
BuildRequires:    kernel-devel-uname-r = %{kernel_version}.%{_arch}

Requires:         kernel-core = %{kernel_version}
Requires:         kernel-core-uname-r = %{kernel_version}.%{_arch}
Requires:         kernel-modules = %{kernel_version}
Requires:         kernel-modules-uname-r = %{kernel_version}.%{_arch}

Provides:         installonlypkg(kernel-module)
Provides:         kernel-modules = %{kernel_version}.%{_arch}
Provides:         %{name}-%{kernel_version}.%{_arch} = %{?epoch:%{epoch}:}%{version}-%{release}

Requires(post):   /usr/sbin/depmod
Requires(postun): /usr/sbin/depmod

Requires(post):   /usr/bin/dracut
Requires(postun): /usr/bin/dracut

Provides:         kmod-iwl3945 = %{?epoch:%{epoch}:}%{version}-%{release}
Provides:         kmod-iwl3945-%{kernel_version}.%{_arch} = %{?epoch:%{epoch}:}%{version}-%{release}

Supplements:      iwl3945-firmware
Recommends:       iwl3945-firmware

Provides:         kmod-iwl4965 = %{?epoch:%{epoch}:}%{version}-%{release}
Provides:         kmod-iwl4965-%{kernel_version}.%{_arch} = %{?epoch:%{epoch}:}%{version}-%{release}

Supplements:      iwl4965-firmware
Recommends:       iwl4965-firmware

%description
This package provides drivers for Intel's WiFi adapter 3945ABG/BG (iwl3945) and
4965AGN (iwl4965) including the required Intel WiFi legacy driver (iwlegacy).


%prep
%autosetup -p1 -n %{pkg}-%{version}


%build
pushd src
%{__make} -C /usr/src/kernels/%{kernel_version}.%{_arch} %{?_smp_mflags} M=$PWD modules
popd


%install
%{__install} -D -t %{buildroot}/lib/modules/%{kernel_version}.%{_arch}/extra/drivers/net/wireless/intel/%{pkg} src/%{pkg}.ko src/iwl3945.ko src/iwl4965.ko

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+


%clean
%{__rm} -rf %{buildroot}


%post
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
touch %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}


%preun
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
touch %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}


%postun
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch} ]
then
    if [ -f /lib/modules/%{kernel_version}.%{_arch}/System.map ]
    then
        /usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}
    fi

    if [ -f /boot/initramfs-%{kernel_version}.%{_arch}.img ]
    then
        if /usr/bin/dracut -f --rebuild /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew %{kernel_version}.%{_arch}
        then
            if ! cmp -s /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            then
                mv /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew /boot/initramfs-%{kernel_version}.%{_arch}.img
            else
                rm -f /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            fi
        fi
    fi

    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
fi


%posttrans
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch} ]
then
    if [ -f /lib/modules/%{kernel_version}.%{_arch}/System.map ]
    then
        /usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}
    fi

    if [ -f /boot/initramfs-%{kernel_version}.%{_arch}.img ]
    then
        if /usr/bin/dracut -f --rebuild /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew %{kernel_version}.%{_arch}
        then
            if ! cmp -s /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            then
                mv /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew /boot/initramfs-%{kernel_version}.%{_arch}.img
            else
                rm -f /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            fi
        fi
    fi

    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
fi


%files
%defattr(644,root,root,755)
/lib/modules/%{kernel_version}.%{_arch}
%license COPYING


%changelog
* Mon Aug 30 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.12-5
- Set specific kernel version to use
- Add Provides kernel-modules
- Add .%{_arch} to kernel-modules provides version
- Rebuild for 4.18.0-338.el8

* Thu Aug 19 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.12-4
- Rebuild for 4.18.0-331.el8

* Tue Aug 17 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.12-3
- Remove dracut conf file

* Tue Aug 17 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.12-2
- Rebuild for 4.18.0-326.el8

* Thu Aug 12 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.12-1
- Initial version
